/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: EventSender.java 6218 2010-03-29 08:25:18Z alitokmen $
 * --------------------------------------------------------------------------
 */

package org.ow2.jasmine.monitoring.tests.events.osgi;

import java.util.logging.Logger;

import org.mule.MuleManager;
import org.mule.extras.client.MuleClient;

/**
 * Event sender.
 * @author Florent Benoit
 */
public class EventSender {

    /**
     * Logger.
     */
    private Logger logger = Logger.getLogger(this.getClass().getName());

    /**
     * Dispatcher on the mule side.
     */
    private static final String DISPATCHER = "vm://MBeanCmd_dispatcher";

    /**
     * First Event.
     */
    private static final String EVENT_1 =
        "mbeancmd_values_v1\n" +
        "date;time;sname;server;domain;mbean;;Item\n" +
        "2009/09/09 09:09:09;1252480149410;service:jmx:rmi:///jndi/rmi://localhost:1099/jrmpconnector_jonas_florent;florentServer;myDomain;myProbe1;;myValue1";

    /**
     * Second Event.
     */
    private static final String EVENT_2 =
        "mbeancmd_values_v1\n" +
        "date;time;sname;server;domain;mbean;;Item\n" +
        "2009/09/09 09:09:09;1252480149410;service:jmx:rmi:///jndi/rmi://localhost:1099/jrmpconnector_jonas_florent;florentServer;myDomain;myProbe2;;myValue2";

    /**
     * Third Event.
     */
    private static final String EVENT_3 =
        "mbeancmd_values_v1\n" +
        "date;time;sname;server;domain;mbean;;Item\n" +
        "2009/09/09 09:09:09;1252480149410;service:jmx:rmi:///jndi/rmi://localhost:1099/jrmpconnector_jonas_florent;florentServer;myDomain;myProbe3;;myValue3";

    public void start() throws Exception {
        while (!MuleManager.isInstanciated()) {
            this.logger.info(this.getClass().getName() + " waiting for MuleManager...");
            Thread.sleep(1000);
        }

        this.logger.info("Starting " + this.getClass().getName() + ", sending events on the JASMINe Events Switch...");

        MuleClient muleClient = new MuleClient();

        // Send 3 events
        muleClient.dispatch(DISPATCHER, EVENT_1, null);
        muleClient.dispatch(DISPATCHER, EVENT_2, null);
        muleClient.dispatch(DISPATCHER, EVENT_3, null);
    }

}
